﻿/// <reference path="jsreference.js" />
var alertURL = '';
var forecastURL = '';
var forecasthourlyURL = '';
var locationURL = '';
var locationsearchURL = '';
var dataURL = '';
var radarURL = '';
var cameraURL = '';
var stationURL = '';

function config() {
}

config.getConfigFile = function () {

    var ko = new Date();
    var ji = ko.getTime();

    var isConfig = false;

    var xmlhttp = null;
    xmlhttp = new XMLHttpRequest();
    var requestTimer = setTimeout(function () {
        isConfig = false;
    }, wxbug.timeoutLen);

    xmlhttp.onreadystatechange = function () {
        if (xmlhttp.readyState === 4) {
            if (xmlhttp.status === 200) {
                clearTimeout(requestTimer);
                isConfig = true;
                configFile = xmlhttp.responseText;
            } else {
                isConfig = false;
                configFile = '';
            }
        }
        else {
            isConfig = false;
            configFile = '';
        }
    };

    xmlhttp.open("GET", "http://direct.weatherbug.com/Nokia/CommandV2.js?rnd=" + String(ji), false);

    try {
        xmlhttp.send(null);
        return (isConfig);
    }
    catch (err) {
        return false;
    }

};

var isGPS = "";

config.loadConfigSettings = function () {

    //clear config preferences
    widget.setPreferenceForKey(null, 'adURL');
    widget.setPreferenceForKey(null, 'dataRefresh');
    widget.setPreferenceForKey(null, 'isAd');
    widget.setPreferenceForKey(null, 'isGPS');
    widget.setPreferenceForKey(null, 'alertURL');
    widget.setPreferenceForKey(null, 'forecastURL');
    widget.setPreferenceForKey(null, 'forecasthourlyURL');
    widget.setPreferenceForKey(null, 'locationURL');
    widget.setPreferenceForKey(null, 'dataURL');
    widget.setPreferenceForKey(null, 'radarURL');
    widget.setPreferenceForKey(null, 'cameraURL');
    widget.setPreferenceForKey(null, 'stationURL');

    var myConfig = {};
    myConfig = eval('(' + configFile + ')');

    var dataRefresh = myConfig.dataRefresh;
    widget.setPreferenceForKey(String(dataRefresh), 'dataRefresh');

    var isAd = myConfig.ad;
    widget.setPreferenceForKey(String(isAd), 'isAd');

    var adURL = myConfig.adURL;
    parent.document.all["widgetAdURL"].innerHTML = adURL;
    widget.setPreferenceForKey(adURL, 'adURL');

    var isGPS = myConfig.gps;
    widget.setPreferenceForKey(String(isGPS), 'isGPS');

    for (var i = 0, len = myConfig.urls.length; i < len; ++i) {
        switch (myConfig.urls[i].type) {
        case "alertURL":
            alertURL = myConfig.urls[i].value;
            widget.setPreferenceForKey(myConfig.urls[i].value, 'alertURL');
            break;
        case "forecastURL":
            forecastURL = myConfig.urls[i].value;
            widget.setPreferenceForKey(myConfig.urls[i].value, 'forecastURL');
            break;
        case "forecasthourlyURL":
            forecasthourlyURL = myConfig.urls[i].value;
            widget.setPreferenceForKey(myConfig.urls[i].value, 'forecasthourlyURL');
            break;
        case "locationURL":
            locationURL = myConfig.urls[i].value;
            widget.setPreferenceForKey(myConfig.urls[i].value, 'locationURL');
            break;
        case "locationsearchURL":
            locationsearchURL = myConfig.urls[i].value;
            widget.setPreferenceForKey(myConfig.urls[i].value, 'locationsearchURL');
            break;
        case "dataURL":
            dataURL = myConfig.urls[i].value;
            widget.setPreferenceForKey(myConfig.urls[i].value, 'dataURL');
            break;
        case "radarURL":
            radarURL = myConfig.urls[i].value;
            widget.setPreferenceForKey(myConfig.urls[i].value, 'radarURL');
            break;
        case "cameraURL":
            cameraURL = myConfig.urls[i].value;
            widget.setPreferenceForKey(myConfig.urls[i].value, 'cameraURL');
            break;
        case "stationURL":
            stationURL = myConfig.urls[i].value;
            widget.setPreferenceForKey(myConfig.urls[i].value, 'stationURL');
            break;
        }
    }
};