﻿/// <reference path="jsreference.js" />

function data() {

}

data.CurrentDay = 0;
data.CurrentAlert = 0;

//Get the Data string
data.getData = function(arrayid, units, city, zip, sid) {

    ko = new Date();
    ji = ko.getTime();

    httpReq = new XMLHttpRequest();
    var requestTimer = setTimeout(function() {
        return null;
    }, wxbug.timeoutLen);
    var response = '';
    httpReq.onreadystatechange = function() {
        if (httpReq.readyState == 4) {
            clearTimeout(requestTimer);
            if (httpReq.status == 200) {
                response = httpReq.responseText;
            }
            else {
                return null;
            }
        }
        else {
            return null;
        }
    }

    httpReq.open("GET", dataURL + "?dt=a&dt=o&dt=f&dt=r&dt=l&ic=0&nf=7&units=" + units + "&city=" + city + "&zip=" + zip + "&sid=" + sid + "&rnd=" + String(ji), false);

    try {
        httpReq.send(null);
        return response;
    }
    catch (err) {
        return null;
    }

};

var CurrStation = {};


//Data Load
data.loadData = function(stationValue) {

    if ((wxbug.gpsOn == 0) & (stationValue == 0) & (myLocations.stations.length == 1)) {
        document.getElementById('addStationCancel').style.display = 'none';
        wxbug.showStationSetup();
    }
    else {

        try {

            if ((wxbug.gpsOn == 0) & (stationValue == 0)) {
                stationValue = 1;
            }

            if ((widget.preferenceForKey('myGPS') == "0") & (stationValue == 0)) {
                stationValue = 1;
            }

            //Get the stored station object
            wxbug.hideAlertDetail();

            try {

                //if it's a stored location then no problem
                CurrStation = eval('(' + widget.preferenceForKey("station_" + stationValue) + ')');

                if (stationValue != 0) {

                    var cityState = myLocations.stations[Number(stationValue)].cityStCtry;
                    var cityStateItem = cityState.split(",");

                    if (myLocations.stations[Number(stationValue)].isUS == 'true') {
                        ad.city = wxbug.trim(cityStateItem[0]);
                        ad.stateterr = wxbug.trim(cityStateItem[1]);
                        ad.country = 'USA';
                        ad.zip = myLocations.stations[Number(stationValue)].zip;
                    }
                    else {
                        ad.city = wxbug.trim(cityStateItem[0]);
                        ad.stateterr = '';
                        ad.country = wxbug.trim(cityStateItem[1]);
                        ad.zip = '';
                    }

                }
                else { //if myGPS then use the stored info in station_
                    if (CurrStation.weather.LocationData.location.city == null | CurrStation.weather.LocationData.location.city == '') {
                        ad.city = '';
                    }
                    else {
                        ad.city = CurrStation.weather.LocationData.location.city;
                    }

                    if (CurrStation.weather.LocationData.location.state == null | CurrStation.weather.LocationData.location.state == '') {
                        ad.stateterr = '';
                    }
                    else {
                        ad.stateterr = CurrStation.weather.LocationData.location.state;
                    }

                    if (CurrStation.weather.LocationData.location.country == null | CurrStation.weather.LocationData.location.country == '') {
                        ad.country = '';
                    }
                    else {
                        ad.country = CurrStation.weather.LocationData.location.country;
                    }

                    if (CurrStation.weather.LocationData.location.zip == null | CurrStation.weather.LocationData.location.zip == '') {
                        ad.zip = '';
                    }
                    else {
                        ad.zip = CurrStation.weather.LocationData.location.zip;
                    }
                    
                }

            }
            catch (err) {
                alert("Ad Error:" + err.message + " City: " + wxbug.trim(cityStateItem[0]) + " State: " + wxbug.trim(cityStateItem[1]));
            }

            try {

                //need to adjust for stored custom name
                var thisLocCityState = '';

                if (CurrStation.weather.LocationData.location.isUs == true) {
                    thisLocCityState = CurrStation.weather.LocationData.location.city + ', ' + CurrStation.weather.LocationData.location.state;
                }
                else {
                    thisLocCityState = CurrStation.weather.LocationData.location.city + ', ' + CurrStation.weather.LocationData.location.country;
                }

                document.getElementById("location.citystatecountry").innerHTML = thisLocCityState;
                document.getElementById("ObsData.stationName").innerHTML = myLocations.stations[stationValue].custName;
            }
            catch (err) {
                alert("Obs Name Error: (" + stationValue + ") " + err.message + " City: " + CurrStation.weather.LocationData.location.city + " State" + CurrStation.weather.LocationData.location.state + " Country" + CurrStation.weather.LocationData.location.country);
            }

            //            document.getElementById("ObsData.combinedLocation").innerHTML = thisLocCityState;
            //            document.getElementById("ObsData.combinedStation").innerHTML = data.isNullValue(myLocations.stations[stationValue].custName);

            ////Don't show the last updated d/t
            //            ko = new Date();
            //            ji = ko.getTime();

            //            var timeDiff = (Number(ji) - Number(widget.preferenceForKey("locUpdated_" + stationValue)));

            //            if (timeDiff >= 7200000) { //two hours
            //                document.getElementById("ObsData.updatedateTime").innerHTML = "Last Updated: " + data.isNullValue(FormatDate(widget.preferenceForKey("locUpdated_" + stationValue)));
            //            }

            try {

                var convWindUnits = '';
                var convWindSpeed = 0;


                var gustSpeed = 0;
                //CurrStation.weather.ObsData.gustSpeed

                var avgWindSpeed = 0;
                //CurrStation.weather.ObsData.avgWindSpeed

                switch (widget.preferenceForKey('settingsWndUnit')) {
                    case '0':
                        if (CurrStation.weather.ForecastData.temperatureUnits == "°C") {
                            gustSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.gustSpeed * .62), 0));
                            avgWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.avgWindSpeed * .62), 0));
                            convWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.windSpeed * .62), 0));
                        }
                        else {
                            gustSpeed = data.isNullValue(CurrStation.weather.ObsData.gustSpeed);
                            avgWindSpeed = data.isNullValue(CurrStation.weather.ObsData.avgWindSpeed);
                            convWindSpeed = data.isNullValue(CurrStation.weather.ObsData.windSpeed);
                        }
                        convWindUnits = 'mph';
                        break;
                    case '1':
                        if (CurrStation.weather.ForecastData.temperatureUnits == "°C") {
                            gustSpeed = data.isNullValue(CurrStation.weather.ObsData.gustSpeed);
                            avgWindSpeed = data.isNullValue(CurrStation.weather.ObsData.avgWindSpeed);
                            convWindSpeed = data.isNullValue(CurrStation.weather.ObsData.windSpeed);
                        }
                        else {
                            gustSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.gustSpeed * 1.609), 0));
                            avgWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.avgWindSpeed * 1.609), 0));
                            convWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.windSpeed * 1.609), 0));
                        }
                        convWindUnits = 'km/h';
                        break;
                    case '2':
                        if (CurrStation.weather.ForecastData.temperatureUnits == "°C") {
                            gustSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.gustSpeed * .54), 0));
                            avgWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.avgWindSpeed * .54), 0));
                            convWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.windSpeed * .54), 0));
                        }
                        else {
                            gustSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.gustSpeed * .869), 0));
                            avgWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.avgWindSpeed * .869), 0));
                            convWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.windSpeed * .869), 0));
                        }
                        convWindUnits = 'kts';
                        break;
                    case '3':
                        if (CurrStation.weather.ForecastData.temperatureUnits == "°C") {
                            gustSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.gustSpeed * .278), 0));
                            avgWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.avgWindSpeed * .278), 0));
                            convWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.windSpeed * .278), 0));
                        }
                        else {
                            gustSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.gustSpeed * .45), 0));
                            avgWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.avgWindSpeed * .45), 0));
                            convWindSpeed = data.isNullValue(wxbug.showdec((CurrStation.weather.ObsData.windSpeed * .45), 0));
                        }
                        convWindUnits = 'm/s';
                        break;

                }

                document.getElementById("windUnits").innerHTML = convWindUnits;
                document.getElementById("windSpeed").innerHTML = convWindSpeed;

            }
            catch (err) {
                alert("Wind Unit Error:" + err.message);
            }

            try {
                changeVaneDir(CurrStation.weather.ObsData.windDeg);
                document.getElementById("temperature").innerHTML = data.isNullValue(CurrStation.weather.ObsData.temperature + ' ' + CurrStation.weather.ObsData.temperatureUnits);

                var TempBarHeight = wxbug.TempBarHeight;
                var TempBarRange = 0;
                var TempBarMax = 0;
                var TempBarMin = 0;
                var TempBarOffset = 0;

                var CurrentTemp = CurrStation.weather.ObsData.temperature;

                if (CurrStation.weather.ForecastData.temperatureUnits == "°C") {
                    TempBarRange = wxbug.TempBarRangeC;
                    TempBarMax = wxbug.TempBarMaxC;
                    TempBarMin = wxbug.TempBarMinC;
                    TempBarOffset = wxbug.TempBarOffsetC;
                }
                else {
                    TempBarRange = wxbug.TempBarRangeF;
                    TempBarMax = wxbug.TempBarMaxF;
                    TempBarMin = wxbug.TempBarMinF;
                    TempBarOffset = wxbug.TempBarOffsetF;
                }

                if (CurrentTemp >= TempBarMax) {
                    document.getElementById("temperaturebar").style.height = TempBarHeight + "px";
                }
                else if (CurrentTemp <= TempBarMin) {
                    document.getElementById("temperaturebar").style.height = "0px";
                }
                else {
                    //Set the level, offset for negative degrees
                    var mytemp = CurrentTemp + TempBarOffset;
                    document.getElementById("temperaturebar").style.height = ((TempBarHeight / TempBarRange) * mytemp) + "px";
                }

            }
            catch (err) {
                alert("Temp Bar Error:" + err.message);
            }

            try {
                //Adjust for later in the day obs
                if (CurrStation.weather.ForecastData.forecastList[0].dayIcon == null) {
                    document.getElementById("dayTitle0").innerHTML = CurrStation.weather.ForecastData.forecastList[0].nightTitle;
                    document.getElementById("dayIcon0").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[0].nightIcon + ".png";
                }
                else {
                    document.getElementById("dayTitle0").innerHTML = CurrStation.weather.ForecastData.forecastList[0].title;
                    document.getElementById("dayIcon0").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[0].dayIcon + ".png";
                }

                document.getElementById("high0").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[0].high) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("low0").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[0].low) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                document.getElementById("dayTitle1").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[1].title);
                document.getElementById("dayIcon1").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[1].dayIcon + ".png";
                document.getElementById("high1").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[1].high) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("low1").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[1].low) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                document.getElementById("highLabel0").innerHTML = rf_high + ":";
                document.getElementById("lowLabel0").innerHTML = rf_low + ":";
                document.getElementById("highLabel1").innerHTML = rf_high + ":";
                document.getElementById("lowLabel1").innerHTML = rf_low + ":";

                //Alerts
                if (CurrStation.weather.AlertData.alertCount == 0) {
                    document.getElementById("alertSpan").style.display = 'none';
                }
                else {

                    document.getElementById("alertNav").style.display = 'none';
                    document.getElementById("alertNavLft").style.display = 'none';
                    document.getElementById("alertNavRght").style.display = 'none';

                    document.getElementById("alertSpan").style.display = 'block';
                    document.getElementById("alertCount").innerHTML = CurrStation.weather.AlertData.alertList.length;

                    //load alert data

                    //adjust for multiple alerts
                    if (CurrStation.weather.AlertData.alertList.length > 1) {
                        document.getElementById("alertNav").style.display = 'block';
                        document.getElementById("alertNavLft").style.display = 'block';
                        document.getElementById("alertNavRght").style.display = 'block';
                    }

                    data.CurrentAlert = 0;
                    data.loadAlert(0);

                }

                //Obs
                document.getElementById("soFarToday").innerHTML = rf_sofartoday;
                //Obs Left
                document.getElementById("obsHi").innerHTML = rf_high + ":";
                document.getElementById("temperatureHigh").innerHTML = data.isNullValue(CurrStation.weather.ObsData.temperatureHigh) + ' ' + CurrStation.weather.ObsData.temperatureUnits + ' ';
                document.getElementById("obsLow").innerHTML = rf_low + ":";
                document.getElementById("temperatureLow").innerHTML = data.isNullValue(CurrStation.weather.ObsData.temperatureLow) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("obsRain").innerHTML = rf_rain + ":";

                document.getElementById("rainDaily").innerHTML = data.isNullValue(CurrStation.weather.ObsData.rainDaily) + CurrStation.weather.ObsData.rainUnits;
                document.getElementById("obsGust").innerHTML = rf_gust + ":";


                document.getElementById("gustSpeed").innerHTML = gustSpeed + convWindUnits + " " + CurrStation.weather.ObsData.gustDirection;
                document.getElementById("obsAvgWind").innerHTML = rf_avgwind + ":";
                document.getElementById("avgWindSpeed").innerHTML = avgWindSpeed + ' ' + convWindUnits;

                document.getElementById("obsRainMnthly").innerHTML = rf_rainmnth + ":";
                document.getElementById("rainMonthly").innerHTML = data.isNullValue(CurrStation.weather.ObsData.rainMonthly) + CurrStation.weather.ObsData.rainUnits;

                //Obs Right
                document.getElementById("obsFeelsLikeLabel").innerHTML = CurrStation.weather.ObsData.feelsLikeLabel + ":";
                document.getElementById("feelsLike").innerHTML = data.isNullValue(CurrStation.weather.ObsData.feelsLike) + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("obsHumidity").innerHTML = rf_humidity + ":";
                document.getElementById("humidity").innerHTML = data.isNullValue(CurrStation.weather.ObsData.humidity) + CurrStation.weather.ObsData.humidityUnits;
                document.getElementById("obsDewPt").innerHTML = rf_dewpoint + ":";
                document.getElementById("dewpoint").innerHTML = data.isNullValue(CurrStation.weather.ObsData.dewpoint) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                //Rising or falling bar icon
                document.getElementById("obsPress").innerHTML = rf_pressure + ":";
                document.getElementById("press").innerHTML = data.isNullValue(CurrStation.weather.ObsData.press) + CurrStation.weather.ObsData.pressUnits;
                var pressureArrw = '';
                if (CurrStation.weather.ObsData.pressRate < 0) {
                    pressureArrw = "images/obs/arrwdwn.png";
                }
                else {
                    pressureArrw = "images/obs/arrwup.png";
                }

                document.getElementById("pressArrw").src = pressureArrw;
                document.getElementById("obsLat").innerHTML = rf_latitude + ":";
                document.getElementById("obsLong").innerHTML = rf_longitude + ":";

                document.getElementById("lat").innerHTML = data.isNullValue(wxbug.showdec(CurrStation.weather.LocationData.location.lat, 2));
                document.getElementById("long").innerHTML = data.isNullValue(wxbug.showdec(CurrStation.weather.LocationData.location.lon, 2));
            }
            catch (err) {
                alert("Main Obs Error:" + err.message);
            }

            try {
                //Forecast
                document.getElementById("forecstTtle").innerHTML = rf_7_dayforecast;

                //first day taken care of in icon section
                document.getElementById("frcstday_1").innerHTML = CurrStation.weather.ForecastData.forecastList[1].title;
                document.getElementById("frcstday_2").innerHTML = CurrStation.weather.ForecastData.forecastList[2].title;
                document.getElementById("frcstday_3").innerHTML = CurrStation.weather.ForecastData.forecastList[3].title;
                document.getElementById("frcstday_4").innerHTML = CurrStation.weather.ForecastData.forecastList[4].title;
                document.getElementById("frcstday_5").innerHTML = CurrStation.weather.ForecastData.forecastList[5].title;
                document.getElementById("frcstday_6").innerHTML = CurrStation.weather.ForecastData.forecastList[6].title;

                //compensate for the day/night
                if (CurrStation.weather.ForecastData.forecastList[0].dayIcon == null) {
                    document.getElementById("frcstday_0").innerHTML = CurrStation.weather.ForecastData.forecastList[0].nightTitle;
                    document.getElementById("frcsticon_0").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[0].nightIcon + ".png";
                    document.getElementById("frcstdesc_0").innerHTML = CurrStation.weather.ForecastData.forecastList[1].nightDesc;
                }
                else {
                    document.getElementById("frcstday_0").innerHTML = CurrStation.weather.ForecastData.forecastList[0].title;
                    document.getElementById("frcsticon_0").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[0].dayIcon + ".png";
                    document.getElementById("frcstdesc_0").innerHTML = CurrStation.weather.ForecastData.forecastList[1].dayDesc;
                }

                document.getElementById("frcsticon_1").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[1].dayIcon + ".png";
                document.getElementById("frcsticon_2").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[2].dayIcon + ".png";
                document.getElementById("frcsticon_3").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[3].dayIcon + ".png";
                document.getElementById("frcsticon_4").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[4].dayIcon + ".png";
                document.getElementById("frcsticon_5").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[5].dayIcon + ".png";
                document.getElementById("frcsticon_6").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[6].dayIcon + ".png";

                document.getElementById("frcst0lbl_hi").innerHTML = rf_high + ":";
                document.getElementById("frcst0txt_hi").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[0].high) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("frcst0lbl_lo").innerHTML = rf_low + ":";
                document.getElementById("frcst0txt_lo").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[0].low) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                document.getElementById("frcst1lbl_hi").innerHTML = rf_high + ":";
                document.getElementById("frcst1txt_hi").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[1].high) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("frcst1lbl_lo").innerHTML = rf_low + ":";
                document.getElementById("frcst1txt_lo").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[1].low) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                document.getElementById("frcst2lbl_hi").innerHTML = rf_high + ":";
                document.getElementById("frcst2txt_hi").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[2].high) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("frcst2lbl_lo").innerHTML = rf_low + ":";
                document.getElementById("frcst2txt_lo").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[2].low) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                document.getElementById("frcst3lbl_hi").innerHTML = rf_high + ":";
                document.getElementById("frcst3txt_hi").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[3].high) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("frcst3lbl_lo").innerHTML = rf_low + ":";
                document.getElementById("frcst3txt_lo").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[3].low) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                document.getElementById("frcst4lbl_hi").innerHTML = rf_high + ":";
                document.getElementById("frcst4txt_hi").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[4].high) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("frcst4lbl_lo").innerHTML = rf_low + ":";
                document.getElementById("frcst4txt_lo").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[4].low) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                document.getElementById("frcst5lbl_hi").innerHTML = rf_high + ":";
                document.getElementById("frcst5txt_hi").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[5].high) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("frcst5lbl_lo").innerHTML = rf_low + ":";
                document.getElementById("frcst5txt_lo").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[5].low) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                document.getElementById("frcst6lbl_hi").innerHTML = rf_high + ":";
                document.getElementById("frcst6txt_hi").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[6].high) + ' ' + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("frcst6lbl_lo").innerHTML = rf_low + ":";
                document.getElementById("frcst6txt_lo").innerHTML = data.isNullValue(CurrStation.weather.ForecastData.forecastList[6].low) + ' ' + CurrStation.weather.ObsData.temperatureUnits;

                document.getElementById("frcstdesc_1").innerHTML = CurrStation.weather.ForecastData.forecastList[1].dayDesc;
                document.getElementById("frcstdesc_2").innerHTML = CurrStation.weather.ForecastData.forecastList[2].dayDesc;
                document.getElementById("frcstdesc_3").innerHTML = CurrStation.weather.ForecastData.forecastList[3].dayDesc;
                document.getElementById("frcstdesc_4").innerHTML = CurrStation.weather.ForecastData.forecastList[4].dayDesc;
                document.getElementById("frcstdesc_5").innerHTML = CurrStation.weather.ForecastData.forecastList[5].dayDesc;
                document.getElementById("frcstdesc_6").innerHTML = CurrStation.weather.ForecastData.forecastList[6].dayDesc;
            }
            catch (err) {
                alert("Forecast Error:" + err.message);
            }

            try {
                //Radar
                document.getElementById("radarAnimate").innerHTML = rf_animate + " " + rf_start;
                document.getElementById("radarLdTtl").innerHTML = "..." + rf_loading + " " + rf_radar + "...";

                if (myLocations.stations[stationValue].isUS == "true") {
                    document.getElementById("radarTtle").innerHTML = rf_local + " " + rf_radar;
                }
                else {
                    document.getElementById("radarTtle").innerHTML = rf_regional + " " + rf_satellite;
                }

                //load the radar only if present
                if (document.getElementById("mainRadar").style.top == wxbug.panelStartLoc + "px") {
                    document.getElementById("radarImg").src = "images/spacer.gif";
                    loadRadarImage();
                }
            }
            catch (err) {
                alert("Radar Error:" + err.message);
            }

            try {
                //Menus
                document.getElementById("menu.horiz.ObsData.temperature").innerHTML = CurrStation.weather.ObsData.temperature + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("menu.horiz.ObsData.temperature_shdw").innerHTML = CurrStation.weather.ObsData.temperature + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("menu.horiz.ObsData.dayIcon").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[1].dayIcon + ".png";

                document.getElementById("menu.btm.ObsData.temperature").innerHTML = CurrStation.weather.ObsData.temperature + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("menu.btm.ObsData.temperature_shdw").innerHTML = CurrStation.weather.ObsData.temperature + CurrStation.weather.ObsData.temperatureUnits;
                document.getElementById("menu.btm.ObsData.dayIcon").src = "images/icons/" + CurrStation.weather.ForecastData.forecastList[1].dayIcon + ".png";

            }
            catch (err) {
                alert("Obs Menu Temp Error:" + err.message);
            }

            try {
                data.loadDayData(data.CurrentDay);
            }
            catch (err) {
                alert("Load Day Data Error:" + err.message);
            }

            document.getElementById('splashScrn').style.display = 'none';
            try {
                createMenu();
            }
            catch (err) {
                alert("Load Menu Error:" + err.message);
            }

        }
        catch (err) {

            //alert("Data Load Error (Reloading): " + err.message);

            //wxbug.loadStations();
            wxbug.showLoadingLoc();
            setTimeout('wxbug.loadStations()', 250);

            //alert("Station Info: " + String(CurrStation));

            //            var stationDataStr = String(data.getData(stationValue, widget.preferenceForKey('settingsTemp'), myLocations.stations[stationValue].cityCode, myLocations.stations[stationValue].zip, myLocations.stations[stationValue].stationID));

            //            if (stationDataStr == null) {
            //                wxbug.noConnectMsg(3);
            //                return;
            //            }
            //            else {
            //                widget.setPreferenceForKey(stationDataStr, 'station_' + stationValue);
            //            }

            //            setTimeout('data.loadData("' + stationValue + '")', 1000);
            //            return;
        }

    }
}

data.isNullValue = function(value) {
    if (String(value) == '' | String(value) == 'null') {
        return '--';
    }
    else {
        return value;
    }
}

//Data Load
data.loadAlert = function(alertIndex) {

    document.getElementById("alertNav").innerHTML = (alertIndex + 1) + ' of ' + CurrStation.weather.AlertData.alertList.length + ' ' + rf_alerts;
    document.getElementById("alertsTitle").innerHTML = CurrStation.weather.AlertData.alertList[alertIndex].description;

    var alertDetail = CurrStation.weather.AlertData.alertList[alertIndex].message;
    document.getElementById("alertsDesc").innerHTML = alertDetail.replace(/,/g, ", ");
    document.getElementById("alertsExpire").innerHTML = rf_expires + ': ' + FormatDate(CurrStation.weather.AlertData.alertList[alertIndex].dateTimeExpires);

}

data.loadAlertUp = function() {

    if ((data.CurrentAlert) == (CurrStation.weather.AlertData.alertList.length - 1)) {
        data.CurrentAlert = 0;
        data.loadAlert(0);
    }
    else {
        data.CurrentAlert += 1;
        data.loadAlert(data.CurrentAlert);
    }
}

data.loadAlertDwn = function() {
    if ((data.CurrentAlert) == 0) {
        data.CurrentAlert = (CurrStation.weather.AlertData.alertList.length - 1);
        data.loadAlert(data.CurrentAlert);
    }
    else {
        data.CurrentAlert -= 1;
        data.loadAlert(data.CurrentAlert);
    }
}

//Data Load
data.loadDayData = function(dayvalue) {

    //Set the day in case they swith stations
    data.CurrentDay = dayvalue;

    //if night icon is null  then don't show night info
    document.getElementById("dailyForecastTtl").innerHTML = rf_dailyforecast + ' ' + FormatForecastDate(CurrStation.weather.ForecastData.forecastList[dayvalue].dateTime);

    //if temp is null then show
    if (CurrStation.weather.ForecastData.forecastList[dayvalue].hasNight == true) {
        document.getElementById("hiiconholder").style.display = 'block';
        document.getElementById("hiiconholdercombined").style.display = 'none';
        document.getElementById("dayForLwrFade").style.display = 'block';
        document.getElementById("dayForeDetailNightHolder").style.display = 'block';

        //look for a null day value
        if (CurrStation.weather.ForecastData.forecastList[dayvalue].high == null) {
            document.getElementById("hiiconholder").style.display = 'none';
            document.getElementById("hiiconholdercombined").style.display = 'none';
        }
    }
    else {
        document.getElementById("hiiconholder").style.display = 'none';
        document.getElementById("hiiconholdercombined").style.display = 'block';
        document.getElementById("dayForLwrFade").style.display = 'none';
        document.getElementById("dayForeDetailNightHolder").style.display = 'none';

        //look for a null night value
        if (CurrStation.weather.ForecastData.forecastList[dayvalue].low == null) {
            document.getElementById("hiiconholder").style.display = 'block';
            document.getElementById("hiiconholdercombined").style.display = 'none';
        }

    }

    document.getElementById("dayForeHi").innerHTML = rf_high + ": " + CurrStation.weather.ForecastData.forecastList[dayvalue].high + ' ' + CurrStation.weather.ObsData.temperatureUnits;
    document.getElementById("dayForeLo").innerHTML = rf_low + ":" + CurrStation.weather.ForecastData.forecastList[dayvalue].low + ' ' + CurrStation.weather.ObsData.temperatureUnits;

    document.getElementById("dayForeHicomb").innerHTML = rf_high + ": " + CurrStation.weather.ForecastData.forecastList[dayvalue].high + ' ' + CurrStation.weather.ObsData.temperatureUnits;
    document.getElementById("dayForeLocomb").innerHTML = rf_low + ":" + CurrStation.weather.ForecastData.forecastList[dayvalue].low + ' ' + CurrStation.weather.ObsData.temperatureUnits;

    document.getElementById("dayForeDayIcon").style.backgroundImage = "url(images/icons/" + CurrStation.weather.ForecastData.forecastList[dayvalue].dayIcon + ".png)";
    document.getElementById("dayForeDayIconcomb").style.backgroundImage = "url(images/icons/" + CurrStation.weather.ForecastData.forecastList[dayvalue].dayIcon + ".png)";

    document.getElementById("dayForeNighIcon").style.backgroundImage = "url(images/icons/" + CurrStation.weather.ForecastData.forecastList[dayvalue].nightIcon + ".png)";

    document.getElementById("dayForeDetailDay").innerHTML = CurrStation.weather.ForecastData.forecastList[dayvalue].dayPred;
    document.getElementById("dayForeDetailNight").innerHTML = CurrStation.weather.ForecastData.forecastList[dayvalue].nightPred;

    document.getElementById("upDayForecast").style.display = 'block';
    document.getElementById("dwnDayForecast").style.display = 'block';

    if (dayvalue == 6) {
        document.getElementById("dwnDayForecast").style.display = 'none';
    }

    if (dayvalue == 0) {
        document.getElementById("upDayForecast").style.display = 'none';
    }

}

data.loadDayDataDwn = function() {

    if (data.CurrentDay == 6) {
        data.CurrentDay = 0;
        data.loadDayData(data.CurrentDay);
    }
    else {
        data.CurrentDay += 1;
        data.loadDayData(data.CurrentDay);
    }
}

data.loadDayDataUp = function() {

    if (data.CurrentDay == 0) {
        data.CurrentDay = 6;
        data.loadDayData(data.CurrentDay);
    }
    else {
        data.CurrentDay -= 1;
        data.loadDayData(data.CurrentDay);
    }
}

function changeVaneDir(windDeg) {

    var roundedValue = roundFifteen(parseInt(windDeg));

    if (roundedValue == "Nan" || roundedValue > 355 || roundedValue < 0 || roundedValue % 15 != 0) {
        roundedValue = 0;
    }

    document.getElementById("imgVane").src = "images/vane/" + roundedValue + ".png";

}

function roundFifteen(value) {
    return ((value % 15 >= 7.5) ? parseInt(value / 15) * 15 + 15 : parseInt(value / 15) * 15);
}

anims = new Array(9);
var frame = 0;
var timeout_state = null;
var radar_animating = false;

function loadRadarImage() {

    document.getElementById("radarAnimate").innerHTML = rf_animate + " " + rf_start;
    clearTimeout(timeout_state);
    timeout_state = null;
    radar_animating = false;
    document.getElementById("radarImg").src = CurrStation.weather.RadarData.mapList[8].imgSrc;
}

function loadRadarAnim() {

    //If stopped start anim
    if (document.getElementById("radarAnimate").innerHTML == (rf_animate + " " + rf_start)) {
        radar_animating = true;
        document.getElementById("radarAnimate").innerHTML = rf_animate + " " + rf_stop;

        for (var i = 0; i <= 8; i++) {
            anims[i] = new Image();
            anims[i].src = CurrStation.weather.RadarData.mapList[i].imgSrc;
        }
        startAnimRadar();
    }
    else {//stop anim
        document.getElementById("radarAnimate").innerHTML = rf_animate + " " + rf_start;
        clearInterval(timeout_state);
        timeout_state = null;
        radar_animating = false;
    }
}

function startAnimRadar() {
    timeout_state = setInterval("animateRadar()", 250);
}

function animateRadar() {

    if (radar_animating != false) {

        if (frame == null) {
            frame = 0;
        }

        document.getElementById("radarImg").src = anims[frame].src;

        if (frame == 8) {
            clearInterval(timeout_state);
            setTimeout('startAnimRadar()', 1500);
            frame = 0;
        }

        frame += 1;

    }
    else {
        clearInterval(timeout_state);
        timeout_state = null;
        frame = 0;
    }

}

function FormatDate(myDate) {

    var hu = new Date(myDate);
    var ji = hu.getTime();
    var ko = new Date(ji);

    var m = ko.getMonth();
    var d = ko.getDate();
    var y = ko.getYear();
    var w = ko.getDay();
    var hour = ko.getHours();
    var min = ko.getMinutes();
    var sec = ko.getSeconds();

    if (m == 0) { m = "Jan"; }
    else if (m == 1) { m = "Feb"; }
    else if (m == 2) { m = "Mar"; }
    else if (m == 3) { m = "Apr"; }
    else if (m == 4) { m = "May"; }
    else if (m == 5) { m = "Jun"; }
    else if (m == 6) { m = "Jul"; }
    else if (m == 7) { m = "Aug"; }
    else if (m == 8) { m = "Sep"; }
    else if (m == 9) { m = "Oct"; }
    else if (m == 10) { m = "Nov"; }
    else { m = "Dec"; }

    d = d + "";
    hour = hour + "";
    min = min + "";
    sec = sec + "";
    y = y + "";

    if (d.match(/^\d$/)) {
        d = "0" + d;
    }
    if (hour.match(/^\d$/)) {
        hour = "0" + hour;
    }
    if (min.match(/^\d$/)) {
        min = "0" + min;
    }
    if (sec.match(/^\d$/)) {
        sec = "0" + sec;
    }

    if (y.match(/^\d\d\d$/)) {
        y = parseFloat(y);
        y = y + 1900;
    }

    if (w == 0) { w = "Sun"; }
    else if (w == 1) { w = "Mon"; }
    else if (w == 2) { w = "Tue"; }
    else if (w == 3) { w = "Wed"; }
    else if (w == 4) { w = "Thu"; }
    else if (w == 5) { w = "Fri"; }
    else { w = "Sat"; }

    var ap = "";

    if (hour < 12) {
        ap = "AM";
    }
    else {
        ap = "PM";
    }
    if (hour == 0) {
        hour = 12;
    }
    if (hour > 12) {
        hour = hour - 12;
    }

    var dth = "";
    if (d == 1 || d == 21 || d == 31) {
        dth = "st";
    }
    else if (d == 2 || d == 22) {
        dth = "nd";
    }
    else if (d == 3 || d == 23) {
        dth = "rd";
    }
    else {
        dth = "th";
    }

    return (m + " " + d + dth + " " + hour + ":" + min + ap);

}

function FormatForecastDate(myDate) {

    var hu = new Date(myDate);
    var ji = hu.getTime();
    var ko = new Date(ji);

    var m = ko.getUTCMonth();
    var d = ko.getUTCDate();
    var w = ko.getUTCDay();
    var y = ko.getUTCFullYear();

    if (m == 0) { m = "Jan"; }
    else if (m == 1) { m = "Feb"; }
    else if (m == 2) { m = "Mar"; }
    else if (m == 3) { m = "Apr"; }
    else if (m == 4) { m = "May"; }
    else if (m == 5) { m = "Jun"; }
    else if (m == 6) { m = "Jul"; }
    else if (m == 7) { m = "Aug"; }
    else if (m == 8) { m = "Sep"; }
    else if (m == 9) { m = "Oct"; }
    else if (m == 10) { m = "Nov"; }
    else { m = "Dec"; }

    d = d + "";

    if (d.match(/^\d$/)) {
        d = "0" + d;
    }

    if (w == 0) { w = "Sun"; }
    else if (w == 1) { w = "Mon"; }
    else if (w == 2) { w = "Tue"; }
    else if (w == 3) { w = "Wed"; }
    else if (w == 4) { w = "Thu"; }
    else if (w == 5) { w = "Fri"; }
    else { w = "Sat"; }

    var dth = "";
    if (d == 1 || d == 21 || d == 31) {
        dth = "st";
    }
    else if (d == 2 || d == 22) {
        dth = "nd";
    }
    else if (d == 3 || d == 23) {
        dth = "rd";
    }
    else {
        dth = "th";
    }
    return (w + " " + m + " " + d + dth);
}

