/// <reference path="jsreference.js" />

var sliderIntervalId = 0;
var sliderLocation = 0;
var sliderStart = 0;
var sliderEnd = 0;
var sliding = false;
var slidingHoriz = false;
var slideSpeed = 100;

function Slide(slideObj, slideStart, slideEnd) {

    //hide the alerts
    wxbug.hideAlertDetail();

    myDiv = document.getElementById(slideObj);
    var thislocation = myDiv.offsetTop;

    if (sliding)
        return;
    sliding = true;
    if (thislocation == (slideStart)) {
        sliderLocation = slideStart;
        sliderIntervalId = setInterval('SlideUpRun("' + slideObj + '", ' + slideStart + ', ' + slideEnd + ')', 125);
    }
    else {
        sliderLocation = slideEnd;
        sliderIntervalId = setInterval('SlideDownRun("' + slideObj + '", ' + slideStart + ', ' + slideEnd + ')', 125);
    }
}

function SlideUpRun(myobj, mystart, myend) {

    slider = document.getElementById(myobj);

    document.getElementById("menu_noclick").style.display = 'block';

    if (myobj == "mainObs") {
        document.getElementById("obsArrowr").src = "images/main/smbtn_close.png";
    }

    if (myobj == "mainRadar") {
        document.getElementById("radarLdTtl").style.display = "block";
        document.getElementById("radarAnimIcon").src = "images/radar/radaranim.gif";
    }

    if (sliderLocation <= myend) {
        sliding = false;
        sliderLocation = myend;
        slider.style.top = myend + 'px';
        clearInterval(sliderIntervalId);

        if (myobj == "mainObs") {
            ad.pageID = 1;
            ad.updateAd();
        }

        if (myobj == "mainRadar") {
            loadRadarImage();
            ad.pageID = 4;
            ad.updateAd();
            if (document.getElementById("mainForecast").style.top == wxbug.panelStartLoc + "px") {
                document.getElementById("mainForecast").style.top = wxbug.panelEndLoc + "px";
            }

            if (document.getElementById("mainForecast").style.left == wxbug.panelStartLoc_horiz + "px") {
                document.getElementById("mainForecast").style.left = wxbug.panelEndLoc_horiz + "px";
            }

            document.getElementById("mainObs").style.top = wxbug.panelLObsLoc + "px";
        }

        if (myobj == "mainForecast") {
            ad.pageID = 2;
            ad.updateAd();
            if (document.getElementById("mainRadar").style.top == wxbug.panelStartLoc + "px") {
                document.getElementById("mainRadar").style.top = wxbug.panelEndLoc + "px";
                document.getElementById("mainObs").style.top = wxbug.panelStartLoc + "px";
                clearTimeout(timeout_state);
                timeout_state = null;
                document.getElementById("radarImg").src = "images/spacer.gif";
            }

            if (document.getElementById("mainForecast").style.left == wxbug.panelStartLoc_horiz + "px") {
                document.getElementById("mainForecast").style.left = wxbug.panelEndLoc_horiz + "px";
            }

            document.getElementById("mainObs").style.top = wxbug.panelLObsLoc + "px";
        }

        document.getElementById("menu_noclick").style.display = 'none';

    }
    else {
        sliderLocation -= slideSpeed;
        if (sliderLocation < myend)
            sliderLocation = myend;
        slider.style.top = sliderLocation + 'px';
    }
}

function SlideDownRun(myobj, mystart, myend) {

    slider = document.getElementById(myobj);

    document.getElementById("menu_noclick").style.display = 'block';

    if (myobj == "mainObs") {
        document.getElementById("obsArrowr").src = "images/main/smbtn_up.png";
    }

    if (sliderLocation >= mystart) {
        sliding = false;
        sliderLocation = mystart;
        slider.style.top = mystart + 'px';
        clearInterval(sliderIntervalId);
        if (myobj == "mainRadar") {
            clearTimeout(timeout_state);
            timeout_state = null;
            document.getElementById("radarImg").src = "images/spacer.gif";
        }

        if (document.getElementById("mainForecast").style.left == wxbug.panelStartLoc_horiz + "px") {
            document.getElementById("mainForecast").style.left = wxbug.panelEndLoc_horiz + "px";
        }

        if (myobj == "mainObs") {
            ad.pageID = 0;
            ad.updateAd();
        }


        if ((document.getElementById("mainForecast").style.top == wxbug.panelEndLoc + "px") & (document.getElementById("mainRadar").style.top == wxbug.panelEndLoc + "px")) {
            ad.pageID = 0;
            ad.updateAd();
        }

        document.getElementById("menu_noclickb").style.display = 'none';
        document.getElementById("condsBtnb").src = "images/menu/btm_cond_on.png";
        document.getElementById("frcstBtnb").src = "images/menu/btm_fc.png";
        document.getElementById("radarBtnb").src = "images/menu/btm_rdr.png";

        document.getElementById("menu_noclick").style.display = 'none';
        document.getElementById("condsBtn").src = "images/menu/hrz_cond_on.png";
        document.getElementById("frcstBtn").src = "images/menu/hrz_fc.png";
        document.getElementById("radarBtn").src = "images/menu/hrz_rdr.png";

    }
    else {
        sliderLocation += slideSpeed;
        if (sliderLocation > mystart)
            sliderLocation = mystart;
        slider.style.top = sliderLocation + 'px';
    }
}


function SlideHoriz(slideObj, slideStart, slideEnd) {

    wxbug.hideAlertDetail();

    myDiv = document.getElementById(slideObj);
    var thislocation = myDiv.offsetLeft;

    if (sliding)
        return;
    slidingHoriz = true;
    if (thislocation == (slideStart)) {
        sliderLocation = slideStart;
        sliderIntervalId = setInterval('SlideLeftRun("' + slideObj + '", ' + slideStart + ', ' + slideEnd + ')', 125);
        ad.pageID = 3;
        ad.updateAd();
    }
    else {
        sliderLocation = slideEnd;
        sliderIntervalId = setInterval('SlideRightRun("' + slideObj + '", ' + slideStart + ', ' + slideEnd + ')', 125);
        ad.pageID = 2;
        ad.updateAd();
    }
}

function SlideLeftRun(myobj, mystart, myend) {

    slider = document.getElementById(myobj);

    if (sliderLocation <= myend) {
        slidingHoriz = false;
        sliderLocation = myend;
        slider.style.left = myend + 'px';
        clearInterval(sliderIntervalId);
    }
    else {

        sliderLocation -= slideSpeed;
        if (sliderLocation < myend)
            sliderLocation = myend;
        slider.style.left = sliderLocation + 'px';
    }
}

function SlideRightRun(myobj, mystart, myend) {

    slider = document.getElementById(myobj);

    if (sliderLocation >= mystart) {

        slidingHoriz = false;
        sliderLocation = mystart;
        slider.style.left = mystart + 'px';
        clearInterval(sliderIntervalId);
    }
    else {
        sliderLocation += slideSpeed;
        if (sliderLocation > mystart)
            sliderLocation = mystart;
        slider.style.left = sliderLocation + 'px';
    }
}
